// note: this example is extremly basic, yet it shows you how to use DPlugger.

Unit Unit1;

Interface

Uses
  sharemem, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  pluginh, pluginlibraryh;              // <-- this two should be here...

Type
  TForm1 = Class(TForm)
    Button1: TButton;
    Procedure Button1Click(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  End;

Var
  Form1             : TForm1;

Implementation

{$R *.DFM}

Procedure TForm1.Button1Click(Sender: TObject);
Var
  PlugInLib         : TPlugInLibrary;   // plugin library object
  pMyPlugIn         : TBasePlugIn;      // plugin object
Begin

  PlugInLib := TPlugInLibrary.create;
  If Not PlugInLib.LoadPlugIn('ex1plugin.dll') Then // load plugin(s) from file
    Begin
      showmessage('could not load plug in');
      PlugInLib.destroy;
      close;
    End;

  showmessage('loaded plug in from ex1plugin.dll');

  // find plugin based on plugin name
  pMyPlugIn := PlugInLib.FindPlugIn('MyPlugin1');
  showmessage(pMyPlugIn.ProcessFile('test1'));
  pMyPlugIn := PlugInLib.FindPlugIn('MyPlugin2');
  showmessage(pMyPlugIn.ProcessFile('test2'));

  // free pMyPlugin...
  PlugInLib.destroy;
End;

Procedure TForm1.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
  action := cafree;
End;

End.

